/**
 * 
 */
package clime.messadmin.model;

import java.util.EventListener;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;

import clime.messadmin.filter.MessAdminRequestWrapper;
import clime.messadmin.filter.MessAdminResponseWrapper;

/**
 * Implementations of this interface recieve notifications about changes
 * to the servlet request of the web application they are part of.
 * Implementation note: we can't use a RequestLifeCycleProvider, as we need our internal wrapper
 * @author C&eacute;drik LIME
 * @see javax.servlet.ServletRequestListener
 * @since Servlet 2.4
 */
public interface IRequestListener extends EventListener {
	/**
	 * Notification that the servlet request is about to go into scope.
	 */
	public void requestInitialized(HttpServletRequest request, ServletContext servletContext);
	/**
	 * Notification that the servlet request is about to go out of scope.
	 */
	public void requestDestroyed(MessAdminRequestWrapper request, MessAdminResponseWrapper response, ServletContext servletContext);
	/**
	 * Notification that the servlet request processing generated an exception.
	 */
	public void requestException(Exception e, MessAdminRequestWrapper request, MessAdminResponseWrapper response, ServletContext servletContext);
}
