/**
 * 
 */
package clime.messadmin.model;

import java.io.File;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author C&eacute;drik LIME
 */
public interface IServerInfo {

	/**
	 * @return server-specific data (user plugin)
	 */
	public List/*<Map.Entry<String, String>>*/ getServerSpecificData();

	/**
	 * @return startup time of this server
	 */
	public Date getStartupTime();

	/**
	 * @since 1.4
	 * @see Runtime#getMaxMemory()
	 */
	public long getMaxMemory();

	/**
	 * @see Runtime#freeMemory()
	 */
	public long getFreeMemory();

	/**
	 * @see Runtime#totalMemory()
	 */
	public long getTotalMemory();

	/**
	 * @since 1.4
	 * @see Runtime#availableProcessors()
	 */
	public int getCpuCount();

	public Map/*<String,String>*/ getSystemProperties();

	/**
	 * @since 1.5
	 * @see System#getenv()
	 */
	public Map/*<String,String>*/ getSystemEnv();

	/**
	 * @return number of bytes available on the partition and includes checks for write permissions and other operating system restrictions
	 * @since 1.6
	 * @see File#getUsableSpace()
	 */
	public long getUsableSpaceForFile(String fileName);
	/**
	 * @return number of bytes available on the partition and includes checks for write permissions and other operating system restrictions
	 * @since 1.6
	 * @see File#getUsableSpace()
	 */
	public long getUsableSpaceForFile(File file);

	/*
	public String getServerInfo();
	*/

	/**
	 * @see System#gc()
	 */
	public void gc();
}