/**
 * 
 */
package clime.messadmin.providers.spi;

import javax.servlet.http.HttpSession;

/**
 * Note: the invocation order of Providers is reversed in case of session/application destruction.
 * @author C&eacute;drik LIME
 */
public interface SessionLifeCycleProvider extends BaseProvider {
	/**
	 * Notification that a session was created.
	 * @param httpSession
	 */
	public void sessionCreated(HttpSession httpSession);
	/**
	 * Notification that a session is about to be invalidated.
	 * @param httpSession
	 */
	public void sessionDestroyed(HttpSession httpSession);

	/** Notification that the session is about to be passivated.*/
    public void sessionWillPassivate(HttpSession httpSession);

    /** Notification that the session has just been activated.*/
    public void sessionDidActivate(HttpSession httpSession);
}
