/**
 * 
 */
package clime.messadmin.providers.userdata;

import java.text.NumberFormat;
import java.util.Enumeration;
import java.util.LinkedList;
import java.util.List;

import javax.servlet.ServletContext;

import clime.messadmin.i18n.I18NSupport;
import clime.messadmin.providers.spi.ApplicationDataProvider;
import clime.messadmin.providers.spi.BaseTabularApplicationDataProvider;

/**
 * @author C&eacute;drik LIME
 */
public class ServletContextInitParametersProvider extends
		BaseTabularApplicationDataProvider implements ApplicationDataProvider {
	private static final String BUNDLE_NAME = ServletContextInitParametersProvider.class.getName();

	/**
	 * 
	 */
	public ServletContextInitParametersProvider() {
		super();
	}

	/** {@inheritDoc} */
	protected String getTableCaption(String[] labels, Object[][] values) {
		NumberFormat numberFormatter = NumberFormat.getNumberInstance(I18NSupport.getAdminLocale());
		String caption = I18NSupport.getLocalizedMessage(BUNDLE_NAME, null, "table.caption", new Object[] {numberFormatter.format(values.length)});//$NON-NLS-1$
		return caption;
	}

	/**
	 * {@inheritDoc}
	 */
	public String[] getApplicationTabularDataLabels(ServletContext context) {
		String name = I18NSupport.getLocalizedMessage(BUNDLE_NAME, null, "label.name");//$NON-NLS-1$
		String value = I18NSupport.getLocalizedMessage(BUNDLE_NAME, null, "label.value");//$NON-NLS-1$
		return new String[] {name, value};
	}

	/**
	 * {@inheritDoc}
	 */
	public Object[][] getApplicationTabularData(ServletContext context) {
		List initParams = new LinkedList();
		Enumeration enumeration = context.getInitParameterNames();
		while (enumeration.hasMoreElements()) {
			String name = (String) enumeration.nextElement();
			String value = context.getInitParameter(name);
			initParams.add(new String[] {name, value});
		}
		Object[][] result = (Object[][]) initParams.toArray(new String[initParams.size()][]);
		return result;
	}

	/**
	 * {@inheritDoc}
	 */
	public String getApplicationDataTitle(ServletContext context) {
		return I18NSupport.getLocalizedMessage(BUNDLE_NAME, null, "title");//$NON-NLS-1$
	}

	/**
	 * {@inheritDoc}
	 */
	public int getPriority() {
		return 0;
	}

}
